(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react'), require('dva')) :
	typeof define === 'function' && define.amd ? define(['react', 'dva'], factory) :
	(global.g_umiUIPlugins = global.g_umiUIPlugins || {}, global.g_umiUIPlugins.blocks = factory(global.React,global.dva));
}(this, (function (react,dva) { 'use strict';

	react = react && react.hasOwnProperty('default') ? react['default'] : react;
	dva = dva && dva.hasOwnProperty('default') ? dva['default'] : dva;

	function unwrapExports (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var model = createCommonjsModule(function (module, exports) {

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = void 0;

	function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

	var _default = {
	  namespace: 'blocks',
	  state: {
	    data: []
	  },
	  subscriptions: {
	    setup({
	      history
	    }) {
	      return history.listen(({
	        pathname
	      }) => {
	        if (pathname === '/blocks') {
	          window.socketReady(() => {
	            window.send('blocks/fetch');
	          });
	        }
	      });
	    }

	  },
	  reducers: {
	    save(state, {
	      payload
	    }) {
	      return _objectSpread({}, state, {
	        data: payload
	      });
	    }

	  }
	};
	exports.default = _default;
	});

	unwrapExports(model);

	var client = createCommonjsModule(function (module, exports) {

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = void 0;

	var _react = _interopRequireDefault(react);



	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	var BlocksViewer = (0, dva.connect)(function (state) {
	  return {
	    blocks: state.blocks
	  };
	})(function (props) {
	  function addHandler(name) {
	    window.send('blocks', [name]);
	  }

	  return _react.default.createElement("div", null, _react.default.createElement("h2", null, "Search"), _react.default.createElement("h2", null, "List"), _react.default.createElement("ul", null, props.blocks.data.map(function (item) {
	    return _react.default.createElement("li", {
	      key: item.name
	    }, item.name, _react.default.createElement("button", {
	      onClick: addHandler.bind(null, item.name)
	    }, "add"));
	  })));
	});

	var _default = function _default(api) {
	  api.addPanel({
	    title: 'Blocks Viewer',
	    path: '/blocks',
	    component: BlocksViewer,
	    models: [model.default]
	  });
	};

	exports.default = _default;
	});

	var client$1 = unwrapExports(client);

	return client$1;

})));
